=== modified file 'loggerhead/tests/test_simple.py'
--- loggerhead/tests/test_simple.py	2007-05-30 08:49:57 +0000
+++ loggerhead/tests/test_simple.py	2007-06-08 10:08:44 +0000
@@ -20,49 +20,65 @@
     assert 'loggerhead branches' in cherrypy.response.body[0]
 
 
-class TestWithSimpleTree(object):
-    config_template = """
-    [project]
-        [[branch]]
-            branch_name = 'branch'
-            folder = '%(branch)s'
-    """
+class BasicTests(object):
+
+
+    # there are so i can run it with py.test and take advantage of the
+    # error reporting...
+    def setup_method(self, meth):
+        self.setUp()
+
+    def teardown_method(self, meth):
+        self.tearDown()
+
     def setUp(self):
-
-        logging.basicConfig(level=logging.DEBUG)
-
+        #logging.basicConfig(level=logging.DEBUG)
+        self.bzrbranch = None
+        self.old_bzrhome = None
+
+    def createBranch(self):
         self.old_bzrhome = bzrlib.osutils.set_or_unset_env('BZR_HOME', '')
         self.bzrbranch = tempfile.mkdtemp()
-        branch = bzrlib.bzrdir.BzrDir.create_branch_convenience(
+        self.branch = bzrlib.bzrdir.BzrDir.create_branch_convenience(
             self.bzrbranch, force_new_tree=True)
-        tree = branch.bzrdir.open_workingtree()
+        self.tree = self.branch.bzrdir.open_workingtree()
+
+    config_template = """
+    [project]
+        [[branch]]
+            branch_name = 'branch'
+            folder = '%(branch)s'
+    """
+
+    def setUpLoggerhead(self):
+        ini = self.config_template%dict(branch=self.bzrbranch)
+
+        config = ConfigObj(ini.splitlines())
+        cherrypy.root = Root(config)
+
+    def tearDown(self):
+        if self.bzrbranch is not None:
+            shutil.rmtree(self.bzrbranch)
+        bzrlib.osutils.set_or_unset_env('BZR_HOME', self.old_bzrhome)
+
+class TestWithSimpleTree(BasicTests):
+
+    def setUp(self):
+        BasicTests.setUp(self)
+        self.createBranch()
+
         f = open(os.path.join(self.bzrbranch, 'myfilename'), 'w')
         self.filecontents = 'some\nmultiline\ndata'
         try:
             f.write(self.filecontents)
         finally:
             f.close()
-        tree.add('myfilename')
-        self.fileid = tree.path2id('myfilename')
+        self.tree.add('myfilename')
+        self.fileid = self.tree.path2id('myfilename')
         self.msg = 'a very exciting commit message'
-        self.revid = tree.commit(message=self.msg)
-
-        ini = self.config_template%dict(branch=self.bzrbranch)
-
-        config = ConfigObj(ini.splitlines())
-        cherrypy.root = Root(config)
-
-    def tearDown(self):
-        shutil.rmtree(self.bzrbranch)
-        bzrlib.osutils.set_or_unset_env('BZR_HOME', self.old_bzrhome)
-
-    # there are so i can run it with py.test and take advantage of the
-    # error reporting...
-    def setup_method(self, meth):
-        self.setUp()
-
-    def teardown_method(self, meth):
-        self.tearDown()
+        self.revid = self.tree.commit(message=self.msg)
+
+        self.setUpLoggerhead()
 
     def test_index(self):
         testutil.create_request('/')
@@ -96,3 +112,15 @@
             folder = '%(branch)s'
             cachepath = '%(branch)s/cache'
     """
+
+class TestEmptyBranch(BasicTests):
+
+    def setUp(self):
+        BasicTests.setUp(self)
+        self.createBranch()
+        self.setUpLoggerhead()
+
+    def test_changes(self):
+        testutil.create_request('/project/branch/changes')
+        assert 'No revisions!' in cherrypy.response.body[0]
+

